/* 2003.12.14
    parent̃NXAppletContainerɕύX
*/
   

package imageFiltering;

import java.awt.*;
import java.awt.image.*;
import java.applet.Applet;

/**
 *	obt@A摜NX (BufferedImagȇ)
 */
public final class AnimatedImage
{
	/** ftHg̃J[f */
	private static final ColorModel CM = DirectColorModel.getRGBdefault();
	
	/** 摜 */
	private String name;
	/** 摜TCY */
	private int width, height;
	/** \摜	 */
	private Image image;
	/** Qƃobt@ */
	private int refBuffer[];
	/** \obt@ */
	private int buffer[];
	/** unsigned int ̔z񂩂 Image 𐶐 */
	private MemoryImageSource MIS;
	/** NbsO͈͂̌Ɏgp */
	private int minX, minY, maxX, maxY;
	/** NbsÖ */
	private Rectangle clipRect;
	
	/** gpAvbg(setupp) */
	private Container parent;
	/** _E[h̊҂ĂAIWỉ摜(setupp) */
	private Image refImage;

	/**
	 * RXgN^
	 *   QƂ錳摜n
	 */
	public AnimatedImage( Container setParent, Image originalImage, String imageName )
	{
		name = imageName;
		parent = setParent;
		refImage = originalImage;
	}
	
	/** 摜̃_E[hĨZbgAbv */
	public void setup()
	{
		width = refImage.getWidth(parent);
		height = refImage.getHeight(parent);
		
		refBuffer = new int[width*height];
		buffer = new int[width*height];
		PixelGrabber PG = new PixelGrabber( refImage, 0, 0, width, height, refBuffer, 0, width );
		try {
			PG.grabPixels();
		} catch ( InterruptedException e ) {}
		MIS = new MemoryImageSource( width, height, buffer, 0, width );
		MIS.setAnimated( true );
		image = parent.createImage( MIS );
		clipRect = new Rectangle();
		this.resetImage();
		refImage = null;
		return;
	}
	
	/** 摜ɃZbg */
	public void resetImage()
	{
		synchronized ( this ) {
			for (int i=0; i<width*height; i++) buffer[i] = refBuffer[i];
			minX = minY = 0;
			maxX = width;
			maxY = height;
		}
		return;
	}
	
	/**
	 * 摜XV(ύX\ɔf)
	 *   XV̈Ԃ
	 */
	public Rectangle update()
	{
		synchronized ( this ) {
			if ( minX < maxX && minY < maxY ) {
				clipRect.setBounds( minX, minY, (maxX+1-minX), (maxY+1-minY) );
				MIS.newPixels( clipRect.x, clipRect.y, clipRect.width, clipRect.height, false );
				minX = width + 1;
				minY = height + 1;
				maxX = -1;
				maxY = -1;
			} else {
				clipRect.setBounds( 0, 0, 0, 0 );
			}
			return clipRect;
		}
	}
	
	/** ̍ĕ`̈摜ŜɃZbg */
	public void repaintAll()
	{
		synchronized ( this ) {
			minX = 0; 
			maxX = width;
			minY = 0; 
			maxY = height;
		}
		return;
	}
	
	/** 摜Ԃ */
	public String getName() {  return name;  }
	/** ImageIuWFNgԂ */
	public Image getImage() {  return image;  }
	/** 摜TCY()Ԃ */
	public int getWidth() {  return width;  }
	/** 摜TCY()Ԃ */
	public int getHeight() {  return height;  }
	
	/** 摜̒̓_ۂԂ */
	public final boolean isContained(int x, int y)
	{
		if ( x<0 || x>=width || y<0 || y>=height ) {
			return false;
		} else {
			return true;
		}
	}
	
	/** QƉ摜̃sNZRlԂ [0, 255] */
	public final int getR( int x, int y ) {  return CM.getRed( refBuffer[x+y*width] );  }
	/** QƉ摜̃sNZGlԂ [0, 255] */
	public final int getG( int x, int y ) {  return CM.getGreen( refBuffer[x+y*width] );  }
	/** QƉ摜̃sNZBlԂ [0, 255] */
	public final int getB( int x, int y ) {  return CM.getBlue( refBuffer[x+y*width] );  }
	
	/** \sNZlZbg */
	public final void setRGB(int x, int y, int R, int G, int B) 
	{
		synchronized ( this ) {
			if ( x < minX ) minX = x;
			if ( x > maxX ) maxX = x;
			if ( y < minY ) minY = y;
			if ( y > maxY ) maxY = y;
			buffer[x+y*width] = (0xFF000000 
								 | (0x00FF0000 & (R << 16)) 
								 | (0x0000FF00 & (G << 8)) 
								 | (0x000000FF & B));
		}
		return;  
	}
	
	/** \sNZlZbg */
	public final void setRGBA(int x, int y, int R, int G, int B, float A) 
	{
		synchronized ( this ) {
			if ( x < minX ) minX = x;
			if ( x > maxX ) maxX = x;
			if ( y < minY ) minY = y;
			if ( y > maxY ) maxY = y;

			int index = x + y * width;
			int rr = (buffer[index] >>> 16) & 0xff;
			int gg = (buffer[index] >>> 8) & 0xff;
			int bb = buffer[index] & 0xff;
			float aa = 1 - A;

			buffer[index] = (0xFF000000 
								 | (0x00FF0000 & ((int)Math.rint(rr * aa + R * A) << 16)) 
								 | (0x0000FF00 & ((int)Math.rint(gg * aa + G * A) << 8)) 
								 | (0x000000FF & (int)Math.rint(bb * aa + B * A)));
		}
		return;  
	}
	
	/** sNZ摜̐FɃZbg */
	public final void resetPixel( int x, int y )
	{
		synchronized ( this ) {
			if ( x < minX ) minX = x;
			if ( x > maxX ) maxX = x;
			if ( y < minY ) minY = y;
			if ( y > maxY ) maxY = y;
			int index = x+y*width;
			buffer[index] = refBuffer[index];
		}
		return;
	}
			

}
