/*---------------------------------------------------------
  摜Applet HaeberliImproveyCgASY
  http://reality.sgi.com/grafica/impression/ Q

  modified by Sato Atushi(2005/01/15)
  `
  --------------------------------------------------------*/


package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;


/**
 * ̊GGiHjɂ悤ȊG𐶐tB^B
 */
public class FilterHaeberliImprove extends Filter 
{
	/** Xg[N̒ */
	int LENGTH = 10;	
	final int LENGTHMAX = 100;
	final int LENGTHMIN = 1;

	/** uV̑傫 */
	int BRUSHSIZE = 8;
	final int BRUSHSIZEMAX = 50;
	final int BRUSHSIZEMIN = 1;

	/** l */
	float ALPHA = .8f;
	final float ALPHAMAX = 1.0f;
	final float ALPHAMIN = 0.01f;
	
	/** uV̌` **/
	int SHAPE = 0;
	
	/** C[W̃\[X */
	protected AnimatedImage AI;

	/** C[W̕ */
	protected int width;

	/** C[W̍ */
	protected int height;


	/** ̃tB^̖̂Ԃ */
	public String getName()
	{
		return "HaeberliImprove";
	}
	
	/** 摜̃tB^Os */
	public void filter(AnimatedImage AI)
	{
		this.AI = AI;
		width = AI.getWidth();
		height = AI.getHeight();

		Random rand = new Random(System.currentTimeMillis());

		//̊G𕜌
		/* rewrite */
		//AI.resetImage();	//ȂĂǂH
		/*
		  for(int y = 0; y < height; y++)
		  for(int x = 0; x < width; x++)
		  AI.setRGB(x, y, AI.getR(x, y), AI.getG(x, y), AI.getB(x, y));
		*/
			
		//obt@̏
		setUpBuffer();

		//_ɃXg[Nzu
		for (int i = 0; i < height; i++) { 
			for(int j = 0; j < width / 10; j++){
			
				/* rewrite */
				int x = Math.abs(rand.nextInt())%width; // xW̓_
				int y = i + Math.abs(rand.nextInt())%((LENGTH + BRUSHSIZE)*4) - (LENGTH + BRUSHSIZE)*2; // yW i-(LENGTH + BRUSHSIZE)*2`i+(LENGTH + BRUSHSIZE)*2 ͈̔́B
				if ( y<0 || y>=height ) continue;
				/*				
					int x = (int)(rand.nextFloat() * (width - 1));
					int y = (int)(rand.nextFloat() * (height - 1));
				*/
			
				//(x,y)̐FRGBl				
				int r = AI.getR(x, y);
				int g = AI.getG(x, y);
				int b = AI.getB(x, y);

				//uVXg[N`
				drawBrushStroke(x, y, r, g, b);
			}
			this.switchThread();	//ύXʂɔf
		}
		this.switchThread();	//ύXʂɔf
		AI.repaintAll();
		return;
	}

	/**
	 * uVXg[NP`悷
	 */
	protected void drawBrushStroke(int x, int y, int r, int g, int b)
	{

		// 摜̋Px̌z擾
		Point dir = getDirection(x, y);  //getDirection\bh͉ɑ݁B
		float vx, vy, l;
		vx = -dir.y/255.0f;
		vy = dir.x/255.0f;
		l = (float)Math.sqrt(vx*vx+vy*vy);
		vx /= l;
		vy /= l;


		//`̈w肷
		int vxl = (int)(vx * LENGTH);
		int vyl = (int)(vy * LENGTH);
		int vxb = (int)(vx * BRUSHSIZE / 2); // 
		int vyb = (int)(vy * BRUSHSIZE / 2); // 
		int sx = x - vxl, sy = y - vyl; //n_(sx,sy)
		int ex = x + vxl, ey = y + vyl; //I_(ex,ey)
	
		/*
		 * Brush Shape𔻕ʁAuVωB
		 */
		switch(SHAPE) {
		case 0: // Circle
			writeCircle(sx, sy, BRUSHSIZE / 2);
			writeCircle(ex, ey, BRUSHSIZE / 2);
			writeLine(sx - vyb, sy + vxb, ex - vyb, ey + vxb);
			writeLine(sx + vyb, sy - vxb, ex + vyb, ey - vxb);
			break;
		case 1: // Square
			writeSquare(sx-BRUSHSIZE / 2, sy-BRUSHSIZE / 2, sx+BRUSHSIZE / 2, sy+BRUSHSIZE / 2);
			writeSquare(ex-BRUSHSIZE / 2, ey-BRUSHSIZE / 2, ex+BRUSHSIZE / 2, ey+BRUSHSIZE / 2);
			writeLine(sx - vyb, sy + vxb, ex - vyb, ey + vxb);
			writeLine(sx + vyb, sy - vxb, ex + vyb, ey - vxb);
			break;
		case 2: // Waterdrop
			writeLine(x, y-LENGTH / 2, x-BRUSHSIZE / 2, y+LENGTH / 2);
			writeLine(x, y-LENGTH / 2, x+BRUSHSIZE / 2, y+LENGTH / 2);
			writeCircle(x, y+LENGTH / 2, BRUSHSIZE / 2);
			break;
		case 3: // ReverseWaterdrop
			writeLine(x, y+LENGTH / 2, x-BRUSHSIZE / 2, y-LENGTH / 2);
			writeLine(x, y+LENGTH / 2, x+BRUSHSIZE / 2, y-LENGTH / 2);
			writeCircle(x, y-LENGTH / 2, BRUSHSIZE / 2);
			break;
		}

		//`̈wFœhԂB
		paintBuffer(r, g, b, ALPHA);
	}


	/**
	 * getDirection\bhBPx̌z擾
	 */
	protected Point getDirection(int x, int y)
	{
		int vx, vy;
		int[][] pixel = {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}};

		for(int i = 0; i < pixel.length; i++){
			int yy = y + i - 1;

			if(yy < 0) continue;
			else if(yy >= height) break;

			for(int j = 0; j < pixel[i].length; j++){
				int xx = x + j - 1;

				if(xx < 0) continue;
				else if(xx >= width) break;

				int r = AI.getR(xx, yy);
				int g = AI.getG(xx, yy);
				int b = AI.getB(xx, yy);

				pixel[i][j] = getLuminance(r, g, b); //Px̎Zo
			}
		}

		vx = -	   pixel[0][0] +	 pixel[0][2]
			- 2 * pixel[1][0] + 2 * pixel[1][2]
			-	  pixel[2][0] + 	pixel[2][2];
		vy = -	   pixel[0][0] +	 pixel[2][0]
			- 2 * pixel[0][1] + 2 * pixel[2][1]
			-	  pixel[0][2] + 	pixel[2][2];

		return new Point(vx, vy);
	}

	/** (r, g, b)PxZo */
	public int getLuminance(int r, int g, int b)
	{
		return (int)(0.3f*r + 0.59f*g + 0.11f*b);
	}


	//**************************************************************************
	//			 ȍ~AOtBbNX֘ÃoLq
	//**************************************************************************

	/* `̈𒲂ׂ邽߂̃obt@B
	 * `͓̈ʂłƉ肵ĂB
	 * {(x, y) | y  {0, ... height - 1}, buf[y][0] <= x <= buf[y][1]}
	 * ŕ\̈悪`̈ƂȂB
	 */
	protected int[][] buf;

	/** yMin:`̈yW̍ŏl */
	protected int yMin;

	/** yMax:`̈yW̍ől */
	protected int yMax;


	/**
	 * buf̏sB
	 * n߂ɂPxĂяoƁB
	 */
	protected void setUpBuffer()
	{
		buf = new int[height][2];
		yMin = 0;
		yMax = height - 1;
		clearBuffer(); //
	}


	/**
	 * buf̓eNAB
	 */
	protected void clearBuffer()
	{
		if(yMin < 0) yMin = 0;
		if(yMax >= height) yMax = height - 1;

		for(int i = yMin; i <= yMax; i++){
			buf[i][0] = width - 1; //ŏl̏l͍ől
			buf[i][1] = 0;	   //ől̏l͍ŏl
		}
		yMin = height - 1; //ŏl̏l͍ől
		yMax = 0;	   //ől̏l͍ŏl
	}


	/**
	 * bufŕ\`̈F(r, g, b, a)œhԂB
	 */
	protected void paintBuffer(int r, int g, int b, float a)
	{
		if(yMin < 0) yMin = 0;
		if(yMax >= height) yMax = height - 1;

		for(int y = yMin; y <= yMax; y++){
			if(buf[y][0] < 0) buf[y][0] = 0;
			if(buf[y][1] >= width) buf[y][1] = width - 1;

			for(int x = buf[y][0]; x <= buf[y][1]; x++){
				AI.setRGBA(x, y, r, g, b, a);
			}
		}

		clearBuffer();
	}


	/**
	 * writePoint\bhB_f[^bufɏށB
	 * yMin, yMax͍XVȂƂɒӁB
	 */
	protected void writePoint(int x, int y)
	{
		if(y < 0 || y >= height) return;

		if(x < buf[y][0]) buf[y][0] = x;
		if(x > buf[y][1]) buf[y][1] = x;
	}


	/**
	 * writeLine\bhBf[^bufɏށB
	 * u[ñASYpĂB
	 */
	protected void writeLine(int x1, int y1, int x2, int y2)
	{
		//yMin, yMax̍XV
		if(y1 < yMin) yMin = y1;
		if(y1 > yMax) yMax = y1;
		if(y2 < yMin) yMin = y2;
		if(y2 > yMax) yMax = y2;

		//dx, dy: X, Y̋
		int dx = x2 - x1, dy = y2 - y1;
		int sx, sy; //dx, dy̕

		if(dx >= 0)
			sx = 1;
		else{
			sx = -1; dx = -dx;
		}
		if(dy >= 0)
			sy = 1;
		else{
			sy = -1; dy = -dy;
		}

		int x = x1, y = y1;
		int d, tmp;

		if(dx >= dy){
			dy += dy; //dy *= 2
			d = dy - dx;
			tmp = dy - 2 * dx;

			writePoint(x, y); //(x, y)check

			for(int i = 0; i < dx; i++){
				if(d > 0){
					y += sy; d += tmp;
				}else
					d += dy;

				x += sx;

				writePoint(x, y); //(x, y)check
			}
		}else{
			dx += dx; //dx *= 2
			d = dx - dy;
			tmp = dx - 2 * dy;

			writePoint(x, y); //(x, y)check

			for(int i = 0; i < dy; i++){
				if(d > 0){
					x += sx; d += tmp;
				}else
					d += dx;

				y += sy;

				writePoint(x, y); //(x, y)check
			}
		}
	}


	/**
	 * writeCircle\bhB~f[^bufɏށB
	 * ~b`Fi[̃ASYgpĂB
	 */
	protected void writeCircle(int x, int y, int r)
	{
		//yMin, yMax̍XV
		if(y - r < yMin) yMin = y - r;
		if(y + r > yMax) yMax = y + r;

		int dx = r, dy = 0;
		
		int d = 0; //l
		d = 3 - 2*r;
		
		while(dx >= dy){
			writePoint(x + dx, y + dy);
			writePoint(x + dx, y - dy);
			writePoint(x - dx, y + dy);
			writePoint(x - dx, y - dy);
			writePoint(x + dy, y + dx);
			writePoint(x + dy, y - dx);
			writePoint(x - dy, y + dx);
			writePoint(x - dy, y - dx);

			//̓_߂
			if(d < 0)
				d += (dy << 2) + 6; //
			else {
				d += ((dy-dx) << 2) + 10; //
				dx--;
			}
			dy++;
		}
	}
	
	/**
	 * ǉwriteSquare\bhB`f[^bufɏށB
	 */
	protected void writeSquare(int x1, int y1, int x2, int y2)
	{
		writeLine(x1,y1,x2,y1);
		writeLine(x1,y1,x1,y2);
		writeLine(x2,y1,x2,y2);
		writeLine(x1,y2,x2,y2);
	}
	
	/**
	 *	p[^암̋Lq
	 */	
	class FilterHaeberliImprovePanel extends FilterPanel implements AdjustmentListener, ItemListener{

		Label L1 = new Label("Haeberli parameter"),
			L2 = new Label("Length"),
			L3 = new Label("Brush size"),
			L4 = new Label("alpha"),
			L5 = new Label("Brush shape");
	
		TextField T1 = new TextField(""+LENGTH,5),
			T2 = new TextField(""+BRUSHSIZE,5),
			T3 = new TextField(""+ALPHA,5);
	  
		Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,LENGTH,1,LENGTHMIN,LENGTHMAX),
			S2 = new Scrollbar(Scrollbar.HORIZONTAL,BRUSHSIZE,1,BRUSHSIZEMIN,BRUSHSIZEMAX),
			S3 = new Scrollbar(Scrollbar.HORIZONTAL,8,
							   1,0,11);
	
		Choice C1 = new Choice();
				
	
	
	
		FilterHaeberliImprovePanel(){
			this.setLayout(new GridLayout(20,1));
			this.add(new Container());
			this.add(this.L1);
		
			this.add(this.L5);			/* ̃tB^ɂǉ */
			this.C1.addItem("Circle");
			this.C1.addItem("Square"); //lp
			this.C1.addItem("Waterdrop"); //H
			this.C1.addItem("ReverseWaterdrop"); //tH
			this.add(this.C1);
		
			this.add(this.L2);
			this.add(this.S1);
			this.add(this.T1);
			this.add(this.L3);
			this.add(this.S2);
			this.add(this.T2);
			this.add(this.L4);
			this.add(this.S3);
			this.add(this.T3);
		
		
		
			S1.addAdjustmentListener(this);
			S2.addAdjustmentListener(this);
			S3.addAdjustmentListener(this);
	
			C1.addItemListener(this);
		}
	
		// tB^̃p[^擾ݒ肷
		public void setFilterParameter(){
			try{
				LENGTH = Integer.parseInt(T1.getText());
			}catch(NumberFormatException e){}
			if(LENGTH > LENGTHMAX) LENGTH = LENGTHMAX;
			if(LENGTH < LENGTHMIN) LENGTH = LENGTHMIN;
			T1.setText(""+LENGTH);
		
			try{
				BRUSHSIZE = Integer.parseInt(T2.getText());
			}catch(NumberFormatException e){}
			if(BRUSHSIZE > BRUSHSIZEMAX) BRUSHSIZE = BRUSHSIZEMAX;
			if(BRUSHSIZE < BRUSHSIZEMIN) BRUSHSIZE = BRUSHSIZEMIN;
			T2.setText(""+BRUSHSIZE);
			try{
				ALPHA = Float.parseFloat(T3.getText());
			}catch(NumberFormatException e){}
			if(ALPHA > ALPHAMAX) ALPHA = ALPHAMAX;
			if(ALPHA < ALPHAMIN) ALPHA = ALPHAMIN;
			T3.setText(""+ALPHA);
		}

		public void adjustmentValueChanged(AdjustmentEvent e)
		{
			int val;
			Scrollbar se = (Scrollbar) e.getSource();
			if(se == S1){
				val = S1.getValue();
				T1.setText(""+val);
			}
			else if(se == S2){
				val = S2.getValue();
				T2.setText(""+val);
			}
			else if(se == S3){
				val = S3.getValue();
				T3.setText(""+val/10.0f);
			}
		}  
	
		public void itemStateChanged(ItemEvent ie)
		{	
			Choice c = (Choice) ie.getItemSelectable();
			SHAPE = c.getSelectedIndex();
		} 
	
	}
	
	// tB^p[^ݒ肷邽߂̃plԂ
	public FilterPanel getFilterPanel(){
		return new	FilterHaeberliImprovePanel();
	}
}
