/*---------------------------------------------------------
  摜Applet PenyCgASY2

  Copyright (C) 2004, Yu Katono
  ver1.00 (2005/1/21)

  --------------------------------------------------------*/


package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;


/**
 * ̊Gy敗ɂ悤ȊG𐶐tB^B
 */
public class Pen extends Filter 
{
    /** Xg[N̒ */
    int LENGTH = 10; 
    final int LENGTHMAX = 50;
    final int LENGTHMIN = 1;

    /** uV̑傫 */
    int BRUSHSIZE = 8;
    final int BRUSHSIZEMAX = 50;
    final int BRUSHSIZEMIN = 1;
    /** ZW**/
    int Gray = 124;
    final int GrayMAX = 200;
    final int GrayMIN = 50;

    /** l */
    float ALPHA = .8f;
    final float ALPHAMAX = 1.0f;
    final float ALPHAMIN = 0.01f;

    /** C[W̃\[X */
    protected AnimatedImage AI;

    /** C[W̕ */
    protected int width;

    /** C[W̍ */
    protected int height;


    /** ̃tB^̖̂Ԃ */
    public String getName()
    {
	return "PenTest";
    }
	
    /** 摜̃tB^Os */
    public void filter(AnimatedImage AI)
    {
	this.AI = AI;
	width = AI.getWidth();
	height = AI.getHeight();

	Random rand = new Random(System.currentTimeMillis());


	//ύXʂɔf
		AI.repaintAll();
		//zCgmCY
		for (int y=0; y<height; y++) 
		{
			for (int x=0; x<width; x++) 
			{
				int r = AI.getR(x, y);
				int g = AI.getG(x, y);
				int b = AI.getB(x, y);
				int G=(int)(0.3*r + 0.59*g + 0.11*b);	  
				double T = 0.2*(1-G/40);
				double P = rand.nextInt()%1.0;
				if(P>=T)AI.setRGB(x, y, 255, 255, 255);
				else AI.setRGB(x, y, 0, 0, 0);		       
			}
			this.switchThread();   //ύXʂɔf
		}
		this.switchThread();	//ύXʂɔf    

	//_ɃXg[Nzu
	for (int i = 0; i < height; i++) {
	    for(int j = 0; j < width/5; j++){
		int x = Math.abs(rand.nextInt()) % width;
		int y = i + Math.abs(rand.nextInt()) % 
		    (LENGTH+BRUSHSIZE);
		if ( y<0 || y>=height ) continue;			
	
        	int r = AI.getR(x, y);
		int g = AI.getG(x, y);
		int b = AI.getB(x, y);


            	int G=(int)(0.299*r+0.587*g+0.114*b);    
                if(G>=3*Gray/2){
		    for(int k=0;k<LENGTH;k++)		  
			AI.setRGB(x+k-LENGTH/2, y+k-LENGTH,255, 255, 255);

		}
                else if(G>=Gray&&G<3*Gray/2){
		    for(int k=0;k<LENGTH;k++)
			AI.setRGB(x+k-LENGTH/2, y+k-LENGTH,170, 170, 170);
		    
		}
                else if(G<Gray&&G>Gray/2){
		    for(int k=0;k<LENGTH;k++)
			AI.setRGB(x+k-LENGTH/2, y+k-LENGTH,80, 80, 80);
		    
		}
                else{
		    for(int k=0;k<LENGTH;k++)
			AI.setRGB(x+k-LENGTH/2, y+k-LENGTH,0, 0, 0);
		    
		}
	    }
	    this.switchThread();	//ύXʂɔf
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;	
    }





    class PenPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Pensketch parameter"),
	    L2 = new Label("Length"),
	    L3 = new Label("Brush size"),
	    L4 = new Label("alpha"),
	L5 = new Label("Gray scale");	
	TextField T1 = new TextField(""+LENGTH,5),
	    T2 = new TextField(""+BRUSHSIZE,5),
	    T3 = new TextField(""+ALPHA,5),
	      T4 = new TextField(""+Gray,5);
	
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,LENGTH,1,LENGTHMIN,LENGTHMAX),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,BRUSHSIZE,1,BRUSHSIZEMIN,BRUSHSIZEMAX),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,8,
			       1,0,11),
  S4 = new Scrollbar(Scrollbar.HORIZONTAL,Gray,1,GrayMIN,GrayMAX);

	PenPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);

	    this.add(this.L4);
	    this.add(this.S3);
	    this.add(this.T3);
	    this.add(this.L5);
	    this.add(this.S4);
	    this.add(this.T4);
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    S4.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		LENGTH = Integer.parseInt(T1.getText());
	    }catch(NumberFormatException e){}
	    if(LENGTH > LENGTHMAX) LENGTH = LENGTHMAX;
	    if(LENGTH < LENGTHMIN) LENGTH = LENGTHMIN;
	    T1.setText(""+LENGTH);
	    
	    try{
		BRUSHSIZE = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(BRUSHSIZE > BRUSHSIZEMAX) BRUSHSIZE = BRUSHSIZEMAX;
	    if(BRUSHSIZE < BRUSHSIZEMIN) BRUSHSIZE = BRUSHSIZEMIN;
	    T2.setText(""+BRUSHSIZE);
	    try{
		ALPHA = Float.parseFloat(T3.getText());
	    }catch(NumberFormatException e){}
	    if(ALPHA > ALPHAMAX) ALPHA = ALPHAMAX;
	    if(ALPHA < ALPHAMIN) ALPHA = ALPHAMIN;
	    T3.setText(""+ALPHA);
   try{
		Gray = Integer.parseInt(T4.getText());
	    }catch(NumberFormatException e){}
	    if(Gray > GrayMAX) Gray = GrayMAX;
	    if(Gray < GrayMIN) Gray = GrayMIN;
	    T4.setText(""+Gray);
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+val/10.0f);
	    }
	    else if(se == S4){
		val = S4.getValue();
		T4.setText(""+val);
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  PenPanel();
    }
}
