/*---------------------------------------------------------
  摜Applet PenyCgASY2

  Copyright (C) 2004, Yu Katono
  ver1.00 (2005/1/21)

  --------------------------------------------------------*/


package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;


/**
 * ̊Gy敗ɂ悤ȊG𐶐tB^B
 */
public class Pensketch extends Filter 
{
    /** Xg[N̒ */
    int LENGTH = 10; 
    final int LENGTHMAX = 50;
    final int LENGTHMIN = 1;

    /** uV̑傫 */
    int BRUSHSIZE = 8;
    final int BRUSHSIZEMAX = 50;
    final int BRUSHSIZEMIN = 1;
    /** ZW**/
    int Gray = 124;
    final int GrayMAX = 200;
    final int GrayMIN = 50;

    /** l */
    float ALPHA = .8f;
    final float ALPHAMAX = 1.0f;
    final float ALPHAMIN = 0.01f;

    /** C[W̃\[X */
    protected AnimatedImage AI;

    /** C[W̕ */
    protected int width;

    /** C[W̍ */
    protected int height;


    /** ̃tB^̖̂Ԃ */
    public String getName()
    {
	return "Pensketch";
    }
	
    /** 摜̃tB^Os */
    public void filter(AnimatedImage AI)
    {
	this.AI = AI;
	width = AI.getWidth();
	height = AI.getHeight();

	Random rand = new Random(System.currentTimeMillis());

	//obt@̏
	setUpBuffer();
        //O[XP[ɕϊ 
	//	AI.repaintAll();
	//	Gray(AI);
	//ύXʂɔf
		AI.repaintAll();
		//zCgmCY
		for (int y=0; y<height; y++) 
		{
			for (int x=0; x<width; x++) 
			{
				int r = AI.getR(x, y);
				int g = AI.getG(x, y);
				int b = AI.getB(x, y);
				int G=getLuminance(r,g,b);	  
				double T = 0.2*(1-G/40);
				double P = rand.nextInt()%1.0;
				if(P>=T)AI.setRGB(x, y, 255, 255, 255);
				else AI.setRGB(x, y, 0, 0, 0);		       
			}
			this.switchThread();   //ύXʂɔf
		}
		this.switchThread();	//ύXʂɔf    

	//_ɃXg[Nzu
	for (int i = 0; i < height; i++) {
	    for(int j = 0; j < width/5; j++){
		int x = Math.abs(rand.nextInt()) % width;
		int y = i + Math.abs(rand.nextInt()) % 
		    (LENGTH+BRUSHSIZE);
		if ( y<0 || y>=height ) continue;			
	
        	int r = AI.getR(x, y);
		int g = AI.getG(x, y);
		int b = AI.getB(x, y);
 
				//uVXg[N`
		drawPenStroke(x, y, r, g, b);	 
	    }
	    this.switchThread();	//ύXʂɔf
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;	
    }

    /**
     * yXg[NP`悷
     */
    protected void drawPenStroke(int x, int y, int r, int g, int b)
    {

	// 摜̋Px̌z擾
	Point dir = getDirection(x, y);
	float vx, vy, l;
	vx = -dir.y/255.0f;
	vy = dir.x/255.0f;
	l = (float)Math.sqrt(vx*vx+vy*vy);
	vx /= l;
	vy /= l;


	//`̈w肷
	int vxl = (int)(vx * LENGTH);
	int vyl = (int)(vy * LENGTH);
	int vxb = (int)(vx * BRUSHSIZE / 2);
	int vyb = (int)(vy * BRUSHSIZE / 2);
	int sx = x - vxl, sy = y - vyl ; //n_
	int ex = x + vxl, ey = y + vyl; //I_

       	writeLine(sx - vyb, sy + vxb, ex - vyb, ey + vxb);
	//`̈wFœhԂB
       	paintBuffer(r, g, b, ALPHA);
    }


    /**
     * Px̌z擾
     */
    protected Point getDirection(int x, int y)
    {
	int vx, vy;
	int[][] pixel = {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}};

	for(int i = 0; i < pixel.length; i++){
	    int yy = y + i - 1;

	    if(yy < 0) continue;
	    else if(yy >= height) break;

	    for(int j = 0; j < pixel[i].length; j++){
		int xx = x + j - 1;

		if(xx < 0) continue;
		else if(xx >= width) break;

		int r = AI.getR(xx, yy);
		int g = AI.getG(xx, yy);
		int b = AI.getB(xx, yy);

		pixel[i][j] = getLuminance(r, g, b);
	    }
	}

	vx = - pixel[0][0] + pixel[0][2]
	    - 2 * pixel[1][0] + 2 * pixel[1][2]
	    - pixel[2][0] + pixel[2][2];
	vy = - pixel[0][0] + pixel[2][0]
	    - 2 * pixel[0][1] + 2 * pixel[2][1]
	    - pixel[0][2] + pixel[2][2];

	return new Point(vx, vy);
    }

    /** (r, g, b)PxZo */
    public int getLuminance(int r, int g, int b)
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }


    //**************************************************************************
    //               ȍ~AOtBbNX֘ÃoLq
    //**************************************************************************

    /* `̈𒲂ׂ邽߂̃obt@B
     * `͓̈ʂłƉ肵ĂB
     * {(x, y) | y  {0, ... height - 1}, buf[y][0] <= x <= buf[y][1]}
     * ŕ\̈悪`̈ƂȂB
     */
	protected int[][] buf;

    /** `̈yW̍ŏl */
    protected int yMin;

    /** `̈yW̍ől */
    protected int yMax;


    /**
     * buf̏sB
     * n߂ɂPxĂяoƁB
     */
    protected void setUpBuffer()
    {
	buf = new int[height][2];
	yMin = 0;
	yMax = height - 1;
	clearBuffer();
    }


    /**
     * buf̓eNAB
     */
    protected void clearBuffer()
    {
	if(yMin < 0) yMin = 0;
	if(yMax >= height) yMax = height - 1;

	for(int i = yMin; i <= yMax; i++){
	    buf[i][0] = width - 1; //ŏl̏l͍ől
	    buf[i][1] = 0;         //ől̏l͍ŏl
	}
	yMin = height - 1; //ŏl̏l͍ől
	yMax = 0;          //ől̏l͍ŏl
    }


    /**
     * bufŕ\`̈F(r, g, b, a)œhԂB
     */
    protected void paintBuffer(int r, int g, int b, float a)
    {
	if(yMin < 0) yMin = 0;
	if(yMax >= height) yMax = height - 1;

	for(int y = yMin; y <= yMax; y++){
	    if(buf[y][0] < 0) buf[y][0] = 0;
	    if(buf[y][1] >= width) buf[y][1] = width - 1;

	    for(int x = buf[y][0]; x <= buf[y][1]; x++){
              	int G=(int)(0.299*r+0.587*g+0.114*b);    
                if(G>=3*Gray/2)
		    AI.setRGBA(x, y,255, 255, 255, a);
                else if(G>=Gray&&G<3*Gray/2)
		    AI.setRGBA(x, y,170, 170, 170, a);
                else if(G<Gray&&G>Gray/2)
		    AI.setRGBA(x, y,80, 80, 80, a);
                else
		    AI.setRGBA(x, y,0, 0, 0, a);
	    }
	}

	clearBuffer();
    }


    /**
     * _f[^bufɏށB
     * yMin, yMax͍XVȂƂɒӁB
     */
    protected void writePoint(int x, int y)
    {
	if(y < 0 || y >= height) return;

	if(x < buf[y][0]) buf[y][0] = x;
	if(x > buf[y][1]) buf[y][1] = x;
    }


    /**
     * f[^bufɏށB
     * u[ñASYpĂB
     */
    protected void writeLine(int x1, int y1, int x2, int y2)
    {
	//yMin, yMax̍XV
	if(y1 < yMin) yMin = y1;
	if(y1 > yMax) yMax = y1;
	if(y2 < yMin) yMin = y2;
	if(y2 > yMax) yMax = y2;

	//dx, dy: X, Y̋
	int dx = x2 - x1, dy = y2 - y1;
	int sx, sy; //dx, dy̕

	if(dx >= 0)
	    sx = 1;
	else{
	    sx = -1; dx = -dx;
	}
	if(dy >= 0)
	    sy = 1;
	else{
	    sy = -1; dy = -dy;
	}

	int x = x1, y = y1;
	int d, tmp;

	if(dx >= dy){
	    dy += dy; //dy *= 2
	    d = dy - dx;
	    tmp = dy - 2 * dx;

	    //(x, y)check
	    writePoint(x, y);

	    for(int i = 0; i < dx; i++){
		if(d > 0){
		    y += sy; d += tmp;
		}else
		    d += dy;

		x += sx;

				//(x, y)check
		writePoint(x, y);
	    }
	}else{
	    dx += dx; //dx *= 2
	    d = dx - dy;
	    tmp = dx - 2 * dy;

	    //(x, y)check
	    writePoint(x, y);

	    for(int i = 0; i < dy; i++){
		if(d > 0){
		    x += sx; d += tmp;
		}else
		    d += dx;

		y += sy;

				//(x, y)check
		writePoint(x, y);
	    }
	}
    }



    class PenPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Pensketch parameter"),
	    L2 = new Label("Length"),
	    L3 = new Label("Brush size"),
	    L4 = new Label("alpha"),
	L5 = new Label("Gray scale");	
	TextField T1 = new TextField(""+LENGTH,5),
	    T2 = new TextField(""+BRUSHSIZE,5),
	    T3 = new TextField(""+ALPHA,5),
	      T4 = new TextField(""+Gray,5);
	
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,LENGTH,1,LENGTHMIN,LENGTHMAX),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,BRUSHSIZE,1,BRUSHSIZEMIN,BRUSHSIZEMAX),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,8,
			       1,0,11),
  S4 = new Scrollbar(Scrollbar.HORIZONTAL,Gray,1,GrayMIN,GrayMAX);

	PenPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);

	    this.add(this.L4);
	    this.add(this.S3);
	    this.add(this.T3);
	    this.add(this.L5);
	    this.add(this.S4);
	    this.add(this.T4);
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    S4.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		LENGTH = Integer.parseInt(T1.getText());
	    }catch(NumberFormatException e){}
	    if(LENGTH > LENGTHMAX) LENGTH = LENGTHMAX;
	    if(LENGTH < LENGTHMIN) LENGTH = LENGTHMIN;
	    T1.setText(""+LENGTH);
	    
	    try{
		BRUSHSIZE = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(BRUSHSIZE > BRUSHSIZEMAX) BRUSHSIZE = BRUSHSIZEMAX;
	    if(BRUSHSIZE < BRUSHSIZEMIN) BRUSHSIZE = BRUSHSIZEMIN;
	    T2.setText(""+BRUSHSIZE);
	    try{
		ALPHA = Float.parseFloat(T3.getText());
	    }catch(NumberFormatException e){}
	    if(ALPHA > ALPHAMAX) ALPHA = ALPHAMAX;
	    if(ALPHA < ALPHAMIN) ALPHA = ALPHAMIN;
	    T3.setText(""+ALPHA);
   try{
		Gray = Integer.parseInt(T4.getText());
	    }catch(NumberFormatException e){}
	    if(Gray > GrayMAX) Gray = GrayMAX;
	    if(Gray < GrayMIN) Gray = GrayMIN;
	    T4.setText(""+Gray);
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+val/10.0f);
	    }
	    else if(se == S4){
		val = S4.getValue();
		T4.setText(""+val);
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  PenPanel();
    }
}
